1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5
6# if --tee was passed, write the output not only to the terminal, but
7# additionally to the file test-results/$BASENAME.out, too.
8case "$GIT_TEST_TEE_STARTED, $* " in
9done,*)
10 # do not redirect again
11 ;;
12*' --tee '*|*' --va'*)
13 mkdir -p test-results
14 BASE=test-results/$(basename "$0" .sh)
15 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
16 echo $? > $BASE.exit) | tee $BASE.out
17 test "$(cat $BASE.exit)" = 0
18 exit
19 ;;
20esac
21
22# Keep the original TERM for say_color
23ORIGINAL_TERM=$TERM
24
25# For repeatability, reset the environment to known value.
26LANG=C
27LC_ALL=C
28PAGER=cat
29TZ=UTC
30TERM=dumb
31export LANG LC_ALL PAGER TERM TZ
32EDITOR=:
33unset VISUAL
34unset GIT_EDITOR
35unset AUTHOR_DATE
36unset AUTHOR_EMAIL
37unset AUTHOR_NAME
38unset COMMIT_AUTHOR_EMAIL
39unset COMMIT_AUTHOR_NAME
40unset EMAIL
41unset GIT_ALTERNATE_OBJECT_DIRECTORIES
42unset GIT_AUTHOR_DATE
43GIT_AUTHOR_EMAIL=author@example.com
44GIT_AUTHOR_NAME='A U Thor'
45unset GIT_COMMITTER_DATE
46GIT_COMMITTER_EMAIL=committer@example.com
47GIT_COMMITTER_NAME='C O Mitter'
48unset GIT_DIFF_OPTS
49unset GIT_DIR
50unset GIT_WORK_TREE
51unset GIT_EXTERNAL_DIFF
52unset GIT_INDEX_FILE
53unset GIT_OBJECT_DIRECTORY
54unset GIT_CEILING_DIRECTORIES
55unset SHA1_FILE_DIRECTORIES
56unset SHA1_FILE_DIRECTORY
57GIT_MERGE_VERBOSITY=5
58export GIT_MERGE_VERBOSITY
59export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
60export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
61export EDITOR
62GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
63
64# Protect ourselves from common misconfiguration to export
65# CDPATH into the environment
66unset CDPATH
67
68unset GREP_OPTIONS
69
70case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
71 1|2|true)
72 echo "* warning: Some tests will not work if GIT_TRACE" \
73 "is set as to trace on STDERR ! *"
74 echo "* warning: Please set GIT_TRACE to something" \
75 "other than 1, 2 or true ! *"
76 ;;
77esac
78
79# Convenience
80#
81# A regexp to match 5 and 40 hexdigits
82_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
83_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
84
85# Each test should start with something like this, after copyright notices:
86#
87# test_description='Description of this test...
88# This test checks if command xyzzy does the right thing...
89# '
90# . ./test-lib.sh
91[ "x$ORIGINAL_TERM" != "xdumb" ] && (
92 TERM=$ORIGINAL_TERM &&
93 export TERM &&
94 [ -t 1 ] &&
95 tput bold >/dev/null 2>&1 &&
96 tput setaf 1 >/dev/null 2>&1 &&
97 tput sgr0 >/dev/null 2>&1
98 ) &&
99 color=t
100
101while test "$#" -ne 0
102do
103 case "$1" in
104 -d|--d|--de|--deb|--debu|--debug)
105 debug=t; shift ;;
106 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
107 immediate=t; shift ;;
108 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
109 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
110 -h|--h|--he|--hel|--help)
111 help=t; shift ;;
112 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
113 verbose=t; shift ;;
114 -q|--q|--qu|--qui|--quie|--quiet)
115 quiet=t; shift ;;
116 --with-dashes)
117 with_dashes=t; shift ;;
118 --no-color)
119 color=; shift ;;
120 --no-python)
121 # noop now...
122 shift ;;
123 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
124 valgrind=t; verbose=t; shift ;;
125 --tee)
126 shift ;; # was handled already
127 --root=*)
128 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
129 shift ;;
130 *)
131 echo "error: unknown test option '$1'" >&2; exit 1 ;;
132 esac
133done
134
135if test -n "$color"; then
136 say_color () {
137 (
138 TERM=$ORIGINAL_TERM
139 export TERM
140 case "$1" in
141 error) tput bold; tput setaf 1;; # bold red
142 skip) tput bold; tput setaf 2;; # bold green
143 pass) tput setaf 2;; # green
144 info) tput setaf 3;; # brown
145 *) test -n "$quiet" && return;;
146 esac
147 shift
148 printf "* %s" "$*"
149 tput sgr0
150 echo
151 )
152 }
153else
154 say_color() {
155 test -z "$1" && test -n "$quiet" && return
156 shift
157 echo "* $*"
158 }
159fi
160
161error () {
162 say_color error "error: $*"
163 GIT_EXIT_OK=t
164 exit 1
165}
166
167say () {
168 say_color info "$*"
169}
170
171test "${test_description}" != "" ||
172error "Test script did not set test_description."
173
174if test "$help" = "t"
175then
176 echo "$test_description"
177 exit 0
178fi
179
180exec 5>&1
181if test "$verbose" = "t"
182then
183 exec 4>&2 3>&1
184else
185 exec 4>/dev/null 3>/dev/null
186fi
187
188test_failure=0
189test_count=0
190test_fixed=0
191test_broken=0
192test_success=0
193
194die () {
195 code=$?
196 if test -n "$GIT_EXIT_OK"
197 then
198 exit $code
199 else
200 echo >&5 "FATAL: Unexpected exit with code $code"
201 exit 1
202 fi
203}
204
205GIT_EXIT_OK=
206trap 'die' EXIT
207
208# The semantics of the editor variables are that of invoking
209# sh -c "$EDITOR \"$@\"" files ...
210#
211# If our trash directory contains shell metacharacters, they will be
212# interpreted if we just set $EDITOR directly, so do a little dance with
213# environment variables to work around this.
214#
215# In particular, quoting isn't enough, as the path may contain the same quote
216# that we're using.
217test_set_editor () {
218 FAKE_EDITOR="$1"
219 export FAKE_EDITOR
220 EDITOR='"$FAKE_EDITOR"'
221 export EDITOR
222}
223
224test_decode_color () {
225 sed -e 's/.\[1m/<WHITE>/g' \
226 -e 's/.\[31m/<RED>/g' \
227 -e 's/.\[32m/<GREEN>/g' \
228 -e 's/.\[33m/<YELLOW>/g' \
229 -e 's/.\[34m/<BLUE>/g' \
230 -e 's/.\[35m/<MAGENTA>/g' \
231 -e 's/.\[36m/<CYAN>/g' \
232 -e 's/.\[m/<RESET>/g'
233}
234
235q_to_nul () {
236 perl -pe 'y/Q/\000/'
237}
238
239q_to_cr () {
240 tr Q '\015'
241}
242
243append_cr () {
244 sed -e 's/$/Q/' | tr Q '\015'
245}
246
247remove_cr () {
248 tr '\015' Q | sed -e 's/Q$//'
249}
250
251test_tick () {
252 if test -z "${test_tick+set}"
253 then
254 test_tick=1112911993
255 else
256 test_tick=$(($test_tick + 60))
257 fi
258 GIT_COMMITTER_DATE="$test_tick -0700"
259 GIT_AUTHOR_DATE="$test_tick -0700"
260 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
261}
262
263# Call test_commit with the arguments "<message> [<file> [<contents>]]"
264#
265# This will commit a file with the given contents and the given commit
266# message. It will also add a tag with <message> as name.
267#
268# Both <file> and <contents> default to <message>.
269
270test_commit () {
271 file=${2:-"$1.t"}
272 echo "${3-$1}" > "$file" &&
273 git add "$file" &&
274 test_tick &&
275 git commit -m "$1" &&
276 git tag "$1"
277}
278
279# Call test_merge with the arguments "<message> <commit>", where <commit>
280# can be a tag pointing to the commit-to-merge.
281
282test_merge () {
283 test_tick &&
284 git merge -m "$1" "$2" &&
285 git tag "$1"
286}
287
288# This function helps systems where core.filemode=false is set.
289# Use it instead of plain 'chmod +x' to set or unset the executable bit
290# of a file in the working directory and add it to the index.
291
292test_chmod () {
293 chmod "$@" &&
294 git update-index --add "--chmod=$@"
295}
296
297# Use test_set_prereq to tell that a particular prerequisite is available.
298# The prerequisite can later be checked for in two ways:
299#
300# - Explicitly using test_have_prereq.
301#
302# - Implicitly by specifying the prerequisite tag in the calls to
303# test_expect_{success,failure,code}.
304#
305# The single parameter is the prerequisite tag (a simple word, in all
306# capital letters by convention).
307
308test_set_prereq () {
309 satisfied="$satisfied$1 "
310}
311satisfied=" "
312
313test_have_prereq () {
314 case $satisfied in
315 *" $1 "*)
316 : yes, have it ;;
317 *)
318 ! : nope ;;
319 esac
320}
321
322# You are not expected to call test_ok_ and test_failure_ directly, use
323# the text_expect_* functions instead.
324
325test_ok_ () {
326 test_success=$(($test_success + 1))
327 say_color "" " ok $test_count: $@"
328}
329
330test_failure_ () {
331 test_failure=$(($test_failure + 1))
332 say_color error "FAIL $test_count: $1"
333 shift
334 echo "$@" | sed -e 's/^/ /'
335 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
336}
337
338test_known_broken_ok_ () {
339 test_fixed=$(($test_fixed+1))
340 say_color "" " FIXED $test_count: $@"
341}
342
343test_known_broken_failure_ () {
344 test_broken=$(($test_broken+1))
345 say_color skip " still broken $test_count: $@"
346}
347
348test_debug () {
349 test "$debug" = "" || eval "$1"
350}
351
352test_run_ () {
353 eval >&3 2>&4 "$1"
354 eval_ret="$?"
355 return 0
356}
357
358test_skip () {
359 test_count=$(($test_count+1))
360 to_skip=
361 for skp in $GIT_SKIP_TESTS
362 do
363 case $this_test.$test_count in
364 $skp)
365 to_skip=t
366 esac
367 done
368 if test -z "$to_skip" && test -n "$prereq" &&
369 ! test_have_prereq "$prereq"
370 then
371 to_skip=t
372 fi
373 case "$to_skip" in
374 t)
375 say_color skip >&3 "skipping test: $@"
376 say_color skip "skip $test_count: $1"
377 : true
378 ;;
379 *)
380 false
381 ;;
382 esac
383}
384
385test_expect_failure () {
386 test "$#" = 3 && { prereq=$1; shift; } || prereq=
387 test "$#" = 2 ||
388 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
389 if ! test_skip "$@"
390 then
391 say >&3 "checking known breakage: $2"
392 test_run_ "$2"
393 if [ "$?" = 0 -a "$eval_ret" = 0 ]
394 then
395 test_known_broken_ok_ "$1"
396 else
397 test_known_broken_failure_ "$1"
398 fi
399 fi
400 echo >&3 ""
401}
402
403test_expect_success () {
404 test "$#" = 3 && { prereq=$1; shift; } || prereq=
405 test "$#" = 2 ||
406 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
407 if ! test_skip "$@"
408 then
409 say >&3 "expecting success: $2"
410 test_run_ "$2"
411 if [ "$?" = 0 -a "$eval_ret" = 0 ]
412 then
413 test_ok_ "$1"
414 else
415 test_failure_ "$@"
416 fi
417 fi
418 echo >&3 ""
419}
420
421test_expect_code () {
422 test "$#" = 4 && { prereq=$1; shift; } || prereq=
423 test "$#" = 3 ||
424 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
425 if ! test_skip "$@"
426 then
427 say >&3 "expecting exit code $1: $3"
428 test_run_ "$3"
429 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
430 then
431 test_ok_ "$2"
432 else
433 test_failure_ "$@"
434 fi
435 fi
436 echo >&3 ""
437}
438
439# test_external runs external test scripts that provide continuous
440# test output about their progress, and succeeds/fails on
441# zero/non-zero exit code. It outputs the test output on stdout even
442# in non-verbose mode, and announces the external script with "* run
443# <n>: ..." before running it. When providing relative paths, keep in
444# mind that all scripts run in "trash directory".
445# Usage: test_external description command arguments...
446# Example: test_external 'Perl API' perl ../path/to/test.pl
447test_external () {
448 test "$#" = 4 && { prereq=$1; shift; } || prereq=
449 test "$#" = 3 ||
450 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
451 descr="$1"
452 shift
453 if ! test_skip "$descr" "$@"
454 then
455 # Announce the script to reduce confusion about the
456 # test output that follows.
457 say_color "" " run $test_count: $descr ($*)"
458 # Run command; redirect its stderr to &4 as in
459 # test_run_, but keep its stdout on our stdout even in
460 # non-verbose mode.
461 "$@" 2>&4
462 if [ "$?" = 0 ]
463 then
464 test_ok_ "$descr"
465 else
466 test_failure_ "$descr" "$@"
467 fi
468 fi
469}
470
471# Like test_external, but in addition tests that the command generated
472# no output on stderr.
473test_external_without_stderr () {
474 # The temporary file has no (and must have no) security
475 # implications.
476 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
477 stderr="$tmp/git-external-stderr.$$.tmp"
478 test_external "$@" 4> "$stderr"
479 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
480 descr="no stderr: $1"
481 shift
482 say >&3 "expecting no stderr from previous command"
483 if [ ! -s "$stderr" ]; then
484 rm "$stderr"
485 test_ok_ "$descr"
486 else
487 if [ "$verbose" = t ]; then
488 output=`echo; echo Stderr is:; cat "$stderr"`
489 else
490 output=
491 fi
492 # rm first in case test_failure exits.
493 rm "$stderr"
494 test_failure_ "$descr" "$@" "$output"
495 fi
496}
497
498# This is not among top-level (test_expect_success | test_expect_failure)
499# but is a prefix that can be used in the test script, like:
500#
501# test_expect_success 'complain and die' '
502# do something &&
503# do something else &&
504# test_must_fail git checkout ../outerspace
505# '
506#
507# Writing this as "! git checkout ../outerspace" is wrong, because
508# the failure could be due to a segv. We want a controlled failure.
509
510test_must_fail () {
511 "$@"
512 test $? -gt 0 -a $? -le 129 -o $? -gt 192
513}
514
515# test_cmp is a helper function to compare actual and expected output.
516# You can use it like:
517#
518# test_expect_success 'foo works' '
519# echo expected >expected &&
520# foo >actual &&
521# test_cmp expected actual
522# '
523#
524# This could be written as either "cmp" or "diff -u", but:
525# - cmp's output is not nearly as easy to read as diff -u
526# - not all diff versions understand "-u"
527
528test_cmp() {
529 $GIT_TEST_CMP "$@"
530}
531
532# Most tests can use the created repository, but some may need to create more.
533# Usage: test_create_repo <directory>
534test_create_repo () {
535 test "$#" = 1 ||
536 error "bug in the test script: not 1 parameter to test-create-repo"
537 owd=`pwd`
538 repo="$1"
539 mkdir -p "$repo"
540 cd "$repo" || error "Cannot setup test environment"
541 "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
542 error "cannot run git init -- have you built things yet?"
543 mv .git/hooks .git/hooks-disabled
544 cd "$owd"
545}
546
547test_done () {
548 GIT_EXIT_OK=t
549 test_results_dir="$TEST_DIRECTORY/test-results"
550 mkdir -p "$test_results_dir"
551 test_results_path="$test_results_dir/${0%.sh}-$$"
552
553 echo "total $test_count" >> $test_results_path
554 echo "success $test_success" >> $test_results_path
555 echo "fixed $test_fixed" >> $test_results_path
556 echo "broken $test_broken" >> $test_results_path
557 echo "failed $test_failure" >> $test_results_path
558 echo "" >> $test_results_path
559
560 if test "$test_fixed" != 0
561 then
562 say_color pass "fixed $test_fixed known breakage(s)"
563 fi
564 if test "$test_broken" != 0
565 then
566 say_color error "still have $test_broken known breakage(s)"
567 msg="remaining $(($test_count-$test_broken)) test(s)"
568 else
569 msg="$test_count test(s)"
570 fi
571 case "$test_failure" in
572 0)
573 say_color pass "passed all $msg"
574
575 test -d "$remove_trash" &&
576 cd "$(dirname "$remove_trash")" &&
577 rm -rf "$(basename "$remove_trash")"
578
579 exit 0 ;;
580
581 *)
582 say_color error "failed $test_failure among $msg"
583 exit 1 ;;
584
585 esac
586}
587
588# Test the binaries we have just built. The tests are kept in
589# t/ subdirectory and are run in 'trash directory' subdirectory.
590TEST_DIRECTORY=$(pwd)
591if test -n "$valgrind"
592then
593 make_symlink () {
594 test -h "$2" &&
595 test "$1" = "$(readlink "$2")" || {
596 # be super paranoid
597 if mkdir "$2".lock
598 then
599 rm -f "$2" &&
600 ln -s "$1" "$2" &&
601 rm -r "$2".lock
602 else
603 while test -d "$2".lock
604 do
605 say "Waiting for lock on $2."
606 sleep 1
607 done
608 fi
609 }
610 }
611
612 make_valgrind_symlink () {
613 # handle only executables
614 test -x "$1" || return
615
616 base=$(basename "$1")
617 symlink_target=$TEST_DIRECTORY/../$base
618 # do not override scripts
619 if test -x "$symlink_target" &&
620 test ! -d "$symlink_target" &&
621 test "#!" != "$(head -c 2 < "$symlink_target")"
622 then
623 symlink_target=../valgrind.sh
624 fi
625 case "$base" in
626 *.sh|*.perl)
627 symlink_target=../unprocessed-script
628 esac
629 # create the link, or replace it if it is out of date
630 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
631 }
632
633 # override all git executables in TEST_DIRECTORY/..
634 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
635 mkdir -p "$GIT_VALGRIND"/bin
636 for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
637 do
638 make_valgrind_symlink $file
639 done
640 OLDIFS=$IFS
641 IFS=:
642 for path in $PATH
643 do
644 ls "$path"/git-* 2> /dev/null |
645 while read file
646 do
647 make_valgrind_symlink "$file"
648 done
649 done
650 IFS=$OLDIFS
651 PATH=$GIT_VALGRIND/bin:$PATH
652 GIT_EXEC_PATH=$GIT_VALGRIND/bin
653 export GIT_VALGRIND
654elif test -n "$GIT_TEST_INSTALLED" ; then
655 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
656 error "Cannot run git from $GIT_TEST_INSTALLED."
657 PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
658 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
659else # normal case, use ../bin-wrappers only unless $with_dashes:
660 git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
661 if ! test -x "$git_bin_dir/git" ; then
662 if test -z "$with_dashes" ; then
663 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
664 fi
665 with_dashes=t
666 fi
667 PATH="$git_bin_dir:$PATH"
668 GIT_EXEC_PATH=$TEST_DIRECTORY/..
669 if test -n "$with_dashes" ; then
670 PATH="$TEST_DIRECTORY/..:$PATH"
671 fi
672fi
673GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
674unset GIT_CONFIG
675GIT_CONFIG_NOSYSTEM=1
676GIT_CONFIG_NOGLOBAL=1
677export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
678
679. ../GIT-BUILD-OPTIONS
680
681GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
682export GITPERLLIB
683test -d ../templates/blt || {
684 error "You haven't built things yet, have you?"
685}
686
687if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
688then
689 GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
690 export GITPYTHONLIB
691 test -d ../git_remote_helpers/build || {
692 error "You haven't built git_remote_helpers yet, have you?"
693 }
694fi
695
696if ! test -x ../test-chmtime; then
697 echo >&2 'You need to build test-chmtime:'
698 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
699 exit 1
700fi
701
702# Test repository
703test="trash directory.$(basename "$0" .sh)"
704test -n "$root" && test="$root/$test"
705case "$test" in
706/*) TRASH_DIRECTORY="$test" ;;
707 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
708esac
709test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
710rm -fr "$test" || {
711 GIT_EXIT_OK=t
712 echo >&5 "FATAL: Cannot prepare test area"
713 exit 1
714}
715
716test_create_repo "$test"
717# Use -P to resolve symlinks in our working directory so that the cwd
718# in subprocesses like git equals our $PWD (for pathname comparisons).
719cd -P "$test" || exit 1
720
721this_test=${0##*/}
722this_test=${this_test%%-*}
723for skp in $GIT_SKIP_TESTS
724do
725 to_skip=
726 for skp in $GIT_SKIP_TESTS
727 do
728 case "$this_test" in
729 $skp)
730 to_skip=t
731 esac
732 done
733 case "$to_skip" in
734 t)
735 say_color skip >&3 "skipping test $this_test altogether"
736 say_color skip "skip all tests in $this_test"
737 test_done
738 esac
739done
740
741# Provide an implementation of the 'yes' utility
742yes () {
743 if test $# = 0
744 then
745 y=y
746 else
747 y="$*"
748 fi
749
750 while echo "$y"
751 do
752 :
753 done
754}
755
756# Fix some commands on Windows
757case $(uname -s) in
758*MINGW*)
759 # Windows has its own (incompatible) sort and find
760 sort () {
761 /usr/bin/sort "$@"
762 }
763 find () {
764 /usr/bin/find "$@"
765 }
766 sum () {
767 md5sum "$@"
768 }
769 # git sees Windows-style pwd
770 pwd () {
771 builtin pwd -W
772 }
773 # no POSIX permissions
774 # backslashes in pathspec are converted to '/'
775 # exec does not inherit the PID
776 ;;
777*)
778 test_set_prereq POSIXPERM
779 test_set_prereq BSLASHPSPEC
780 test_set_prereq EXECKEEPSPID
781 ;;
782esac
783
784test -z "$NO_PERL" && test_set_prereq PERL
785test -z "$NO_PYTHON" && test_set_prereq PYTHON
786
787# test whether the filesystem supports symbolic links
788ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
789rm -f y